#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <stdint.h>
#include <string.h>


typedef enum {
    SSE3=0,
    VSX,
    MMX,
    SSE,
    SSE2,
    MONITOR,
    ACPI,
    RDTSCP,
    VMX,
    EIST,
    TM,
    TM2,
    AES,
    RDRAND,
    SSSE3,
    SSE41,
    SSE42,
    AVX,
    AVX2,
    FMA} FeatureBit;


int main(int argc, char* argv[])
{
    int ret;
    FILE* file;
    char buf[1024];
    char ident[30];
    char delimiter[] = " ";
    char* cptr;
    uint32_t featureFlags;
    char* features;


    if ( (file = fopen( "/proc/cpuinfo", "r")) == NULL )
    {
        fprintf(stderr, "Cannot open /proc/cpuinfo\n");
        return -1;
    }

    while( fgets(buf, sizeof(buf)-1, file) )
    {
        ret = sscanf(buf, "%s\t:", &(ident[0]));
        if (ret != 1 || strcmp(ident,"flags") != 0)
            continue;
        else
            break;
    }
    fclose(file);
    featureFlags = 0;
    features = (char*) malloc(200*sizeof(char));

    cptr = strtok(&(buf[9]),delimiter);

    while (cptr != NULL)
    {
        if (strcmp(cptr,"ssse3") == 0)
        {
            featureFlags |= (1<<SSSE3);
            strcat(features, "SSSE3 ");
        }
        else if (strcmp(cptr,"sse3") == 0)
        {
            featureFlags |= (1<<SSE3);
            strcat(features, "SSE3 ");
        }
        else if (strcmp(cptr,"vsx") == 0)
        {
            featureFlags |= (1<<VSX);
            strcat(features, "VSX ");
        }
        else if (strcmp(cptr,"monitor") == 0)
        {
            featureFlags |= (1<<MONITOR);
            strcat(features, "MONITOR ");
        }
        else if (strcmp(cptr,"mmx") == 0)
        {
            featureFlags |= (1<<MMX);
            strcat(features, "MMX ");
        }
        else if (strcmp(cptr,"sse") == 0)
        {
            featureFlags |= (1<<SSE);
            strcat(features, "SSE ");
        }
        else if (strcmp(cptr,"sse2") == 0)
        {
            featureFlags |= (1<<SSE2);
            strcat(features, "SSE2 ");
        }
        else if (strcmp(cptr,"acpi") == 0)
        {
            featureFlags |= (1<<ACPI);
            strcat(features, "ACPI ");
        }
        else if (strcmp(cptr,"rdtscp") == 0)
        {
            featureFlags |= (1<<RDTSCP);
            strcat(features, "RDTSCP ");
        }
        else if (strcmp(cptr,"vmx") == 0)
        {
            featureFlags |= (1<<VMX);
            strcat(features, "VMX ");
        }
        else if (strcmp(cptr,"eist") == 0)
        {
            featureFlags |= (1<<EIST);
            strcat(features, "EIST ");
        }
        else if (strcmp(cptr,"tm") == 0)
        {
            featureFlags |= (1<<TM);
            strcat(features, "TM ");
        }
        else if (strcmp(cptr,"tm2") == 0)
        {
            featureFlags |= (1<<TM2);
            strcat(features, "TM2 ");
        }
        else if (strcmp(cptr,"aes") == 0)
        {
            featureFlags |= (1<<AES);
            strcat(features, "AES ");
        }
        else if (strcmp(cptr,"rdrand") == 0)
        {
            featureFlags |= (1<<RDRAND);
            strcat(features, "RDRAND ");
        }
        else if (strcmp(cptr,"sse4_1") == 0)
        {
            featureFlags |= (1<<SSE41);
            strcat(features, "SSE41 ");
        }
        else if (strcmp(cptr,"sse4_2") == 0)
        {
            featureFlags |= (1<<SSE42);
            strcat(features, "SSE42 ");
        }
        else if (strncmp(cptr,"avx2", 4) == 0)
        {
            featureFlags |= (1<<AVX2);
            strcat(features, "AVX2 ");
        }
        else if (strncmp(cptr,"avx", 3) == 0)
        {
            featureFlags |= (1<<AVX);
            strcat(features, "AVX ");
        }
        else if (strcmp(cptr,"fma") == 0)
        {
            featureFlags |= (1<<FMA);
            strcat(features, "FMA ");
        }
        cptr = strtok(NULL, delimiter);
    }
    printf("Flags: %s\n",features);
    //printf("Features: 0x%x\n",featureFlags);
    return 0;
}
