#!/bin/bash -l
#SBATCH --nodes=4
#SBATCH --ntasks=4
#SBATCH --time=06:00:00
#SBATCH --job-name=Testjob
set -x

# For SLURM variables see:
# https://slurm.schedmd.com/sbatch.html#SECTION_OUTPUT-ENVIRONMENT-VARIABLES

# jobs always start in $HOME: change to a temporary job dir on $WOODYHOME
mkdir ${WOODYHOME}/$SLURM_JOB_ID
cd ${WOODYHOME}/$SLURM_JOB_ID
# copy input file from location where job was submitted, and run
cp ${SLURM_SUBMIT_DIR}/job1.sh .
srun ./job1.sh > job1.output
# save output
mkdir -p ${WOODYHOME}/output/$SLURM_JOB_ID
cp job1.output ${WOODYHOME}/output/$SLURM_JOB_ID
cd
# get rid of the temporary job dir
rm -rf ${WOODYHOME}/$SLURM_JOB_ID

