#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdint.h>

#ifdef _OPENMP
#include <omp.h>
#endif

#include "../snippets/walltime.h"

int main(int argc, char **argv)
{
    const double fPi25DT = 3.141592653589793238462643;
    double fPi;
    double startt, endt;
    uint64_t x = 0;
    uint64_t n = 2000000000;
    const double fH   = 1.0 / (double) n;
    double fSum = 0.0;

    startt = timestamp();
#pragma omp parallel for reduction(+:fSum)
    for (x = 0; x < n; x++)
    {
        double fX = fH * ((double)x + 0.5);
        fSum += (4.0 / (1.0 + fX*fX));
    }
    fPi = fH * fSum;

    endt = timestamp();

    printf("Pi is approximately = %.20f\n", fPi);
    printf("Error               = %.20f\n", fabs(fPi - fPi25DT));
    printf("Wall clock time     = %.20f\n", endt - startt);
    return 0;
}
