#define _GNU_SOURCE
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <sched.h>
//#define NUM_THREADS	8

void *PrintHello(void *threadid)
{
    long tid;
    tid = (long)threadid;
    printf("Hello World! It's me, thread #%ld on CPU %d!\n", tid, sched_getcpu());
    if (tid != 0) pthread_exit(NULL);
}

int main(int argc, char *argv[])
{
    int nthreads = 5;
    if (getenv("OMP_NUM_THREADS") != NULL)
    {
        nthreads = atoi(getenv("OMP_NUM_THREADS"));
    }
    pthread_t threads[nthreads];
    int rc;
    long t;
    printf("In main: master runs currently on CPU %d, used as first thread. Will be pinned when second thread is created.\n", sched_getcpu());

    for(t=1;t<nthreads;t++)
    {
        printf("In main: creating thread %ld\n", t);
        rc = pthread_create(&threads[t], NULL, PrintHello, (void *)t);
        if (rc){
            printf("ERROR; return code from pthread_create() is %d\n", rc);
            exit(-1);
        }
    }
    PrintHello((void*)0);

    /* Last thing that main() should do */
    pthread_exit(NULL);
}
