#include <omp.h>


void copy(int size, double* dst, double* src)
{
    int j=0;

#ifdef _OPENMP
#pragma omp parallel
{
#endif
#ifdef _OPENMP
#pragma omp for simd
#endif
    for (j=0; j<size; j++)
    {
        dst[j] = src[j];
    }
#ifdef _OPENMP
}
#endif
}

void scale(int size, double* dst, double* src, double scalar)
{
    int j=0;
#ifdef _OPENMP
#pragma omp parallel
{
#endif
#ifdef _OPENMP
#pragma omp for simd
#endif
    for (j=0; j<size; j++)
    {
        dst[j] = scalar * src[j];
    }
#ifdef _OPENMP
}
#endif
}

void add(int size, double* dst, double* src1, double* src2)
{
    int j=0;
#ifdef _OPENMP
#pragma omp parallel
{
#endif
#ifdef _OPENMP
#pragma omp for simd
#endif
    for (j=0; j<size; j++)
    {
        dst[j] = src1[j] + src2[j];
    }
#ifdef _OPENMP
}
#endif
}

void triad(int size, double* dst, double* src1, double* src2, double* src3)
{
    int j=0;
#ifdef _OPENMP
#pragma omp parallel
{
#endif
#ifdef _OPENMP
#pragma omp for simd
#endif
    for (j=0; j<size; j++)
    {
        dst[j] = (src1[j] * src2[j]) + src3[j];
    }
#ifdef _OPENMP
}
#endif
}
